-- verificar se j foi gerado o pedido no sistema ao importar (campo DOCUMENTO) gravar na tabela de PEDIDOEXOL

create or replace
PROCEDURE MHA_IMPORTA_MOV_ESTOQUE(XML_ARQ IN CLOB,
                                  P_ERRO OUT VARCHAR2,
                                  P_SEQLOG NUMBER DEFAULT -1)
IS
   L_XMLTYPE XMLTYPE;
   
   V_ERRO           VARCHAR2(1);
   V_DESCERRO       VARCHAR2(1000);

   V_DTPROCESSA     DATE;

   V_IDVALDTAF      VARCHAR2(1);
   V_CDEMPRESA      VARCHAR2(2);
   V_CDFILCENTCMP   VARCHAR2(4);
   V_QUANT_ESTOQUE  FLOAT;
   V_QTDE_DISP      FLOAT;

   V_NRDOCUMENTO    VARCHAR2(20);

   V_CDFILIAL       VARCHAR2(4);
   V_NRPEDEXOL      VARCHAR2(20);
   V_DATAEFETIVACAO DATE;
   V_CODPRODUTO     VARCHAR2(20);
   V_QUANTIDADE     FLOAT;
   V_CDLOTE         VARCHAR2(30);
   V_CDSUBGRPROD    VARCHAR2(10);

   V_CDPRODUTO      VARCHAR2(10);
   V_CDLOTENVITOL   VARCHAR2(10);
   V_CDMARCA        VARCHAR2(5);

   V_CDFILNOVA      VARCHAR2(4);
   V_CDLOTENOVO     VARCHAR2(30);
   V_CDSUBGRNOVO    VARCHAR2(10);
   
   V_SEQLOGITEM NUMBER;
   
   CURSOR C_MOV_ESTOQUE IS
      SELECT F.CDFILIAL, X_N.DOCUMENTO, TRUNC(SYSDATE), SUBSTR(X_N.CODPRODUTO, 1, 20), X_N.QUANTIDADE, X_N.CENTRODESTINO, S.CDSUBGRPROD
        FROM XML_PARSE X,
             XMLTABLE('/Movimentacao'
                      PASSING X.XML_INSERT
                      COLUMNS
                      "EMPRESA"        VARCHAR2(10) PATH '/Movimentacao/EMPRESA'
                      ,"FILIAL"        VARCHAR2(10) PATH '/Movimentacao/FILIAL'
                      ,"DOCUMENTO"     VARCHAR2(20) PATH '/Movimentacao/DOCUMENTO'
                      ,"CODPRODUTO"    VARCHAR2(40) PATH '/Movimentacao/CODPRODUTO'
                      ,"QUANTIDADE"    FLOAT        PATH '/Movimentacao/QUANTIDADE'
                      ,"CENTRODESTINO" VARCHAR2(30) PATH '/Movimentacao/CENTRODESTINO'
                      ) X_N,
             FILIAL F, PARAMFILIAL R, PRODUTO P, PRSUBGRPROD PR, SUBGRUPPROD SUB, SAP_SUBGRUPPRODFIL S 
       WHERE R.CDFILWMSMHA   = X_N.FILIAL
         AND F.CDFILIAL      = R.CDFILIAL
         AND P.CDPRODUTO     = PR.CDPRODUTO
         AND PR.CDGRUPPROD   = SUB.CDGRUPPROD
         AND PR.CDSUBGRPROD  = SUB.CDSUBGRPROD
         AND SUB.CDGRUPPROD  = S.CDGRUPPROD
         AND SUB.CDSUBGRPROD = S.CDSUBGRPROD
         AND S.CDFILIAL      = F.CDFILIAL
         AND X_N.CENTRODESTINO IS NOT NULL
       ORDER BY F.CDFILIAL, X_N.CENTRODESTINO, S.CDSUBGRPROD;
   
   PROCEDURE INSERE_LOGITEM(P_SEQLOGITEM OUT NUMBER)
   IS
   BEGIN
      IF (P_SEQLOG > -1) THEN
         SELECT MAX(SEQLOGITEM)+1
           INTO P_SEQLOGITEM
           FROM USR_LOGITEM_INTEGRACAO;
         BEGIN
            INSERT INTO USR_LOGITEM_INTEGRACAO(SEQLOG, SEQLOGITEM, CDDADOS, HORAENV, HORAREC)
            VALUES(P_SEQLOG, P_SEQLOGITEM, V_NRDOCUMENTO,  SYSDATE, SYSDATE);
         EXCEPTION
            WHEN OTHERS THEN
               P_SEQLOGITEM := NULL;
         END;
      ELSE
         P_SEQLOGITEM := NULL;
      END IF;
   END;   
BEGIN
   DELETE FROM XML_PARSE;
   L_XMLTYPE := XMLTYPE(XML_ARQ);
   INSERT INTO XML_PARSE(XML_INSERT) VALUES(L_XMLTYPE);
   COMMIT;
   
   V_NRPEDEXOL    := '';

   V_CDFILNOVA    := ' ';
   V_CDLOTENOVO   := ' ';
   V_CDSUBGRNOVO  := ' ';
   
   V_QTDE_DISP    := 0;
   
   OPEN C_MOV_ESTOQUE;
   LOOP
      FETCH C_MOV_ESTOQUE INTO V_CDFILIAL, V_NRDOCUMENTO, V_DATAEFETIVACAO, V_CODPRODUTO, V_QUANTIDADE, V_CDLOTE, V_CDSUBGRPROD;
      EXIT WHEN C_MOV_ESTOQUE%NOTFOUND;

      -- continuar o processo com a tabela de relacionamento entre filial e subgrupo
      -- para agrupar os pedidos pelo lote, o order by cdfilial, lote e subgrupo
      -- trocar a linha de baixo para tratar a troca por o documento levando em considerao os campos cdfilial, lote e subgrupo
      -- criar 3 variaveis
      -- Insere lanamento do inventrio 
      IF ((V_CDFILIAL <> V_CDFILNOVA) OR (V_CDLOTE <> V_CDLOTENOVO) OR (V_CDSUBGRPROD <> V_CDSUBGRNOVO)) THEN
         V_ERRO := NULL;
         V_CDFILNOVA   := V_CDFILIAL;
         V_CDLOTENOVO  := V_CDLOTE;
         V_CDSUBGRNOVO := V_CDSUBGRPROD;
         
         BEGIN
            SELECT DECODE(PG.IDUTILDTPROC,'S',NVL(PF.DTPROCESSA, TRUNC(SYSDATE)),TRUNC(SYSDATE)) AS DTPROCESSA,
                   IDVALDTAF, F.CDEMPRESA, F.CDFILCENTCMP
              INTO V_DTPROCESSA,
                   V_IDVALDTAF, V_CDEMPRESA, V_CDFILCENTCMP
              FROM PARAMGERAL PG, PARASUPRI P, PARAMFILIAL PF, FILIAL F
             WHERE PG.CDPARGERAL = '0001'
               AND PF.CDFILIAL   = V_CDFILIAL
               AND F.CDFILIAL    = V_CDFILIAL
               AND P.CDFILIAL    = NVL(F.CDFILCENTCMP, F.CDFILIAL);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTPROCESSA := SYSDATE;
               V_IDVALDTAF  := 'D'; V_CDEMPRESA := NULL; V_CDFILCENTCMP := NULL;
         END;

         IF (V_IDVALDTAF = 'D') THEN
            IF (V_DATAEFETIVACAO > V_DTPROCESSA) THEN
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Data de lanamento deve ser menor ou igual a data de processamento da filial OL.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         ELSIF (TO_CHAR(V_DATAEFETIVACAO, 'MM') > TO_CHAR(V_DTPROCESSA, 'MM')) THEN
            INSERE_LOGITEM(V_SEQLOGITEM);
            V_DESCERRO := 'Ms de lanamento deve ser menor ou igual ao ms de processamento.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);

            V_ERRO := 'S';
         END IF;
         
         BEGIN
            SELECT CDMARCA
              INTO V_CDMARCA
              FROM PARASUPRI
             WHERE CDFILIAL = NVL(V_CDFILCENTCMP, V_CDFILIAL);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDMARCA := NULL;
         END;
         
         IF V_CDMARCA IS NULL THEN
            INSERE_LOGITEM(V_SEQLOGITEM);
            V_DESCERRO := 'No h marca cadastrada para a filial.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);

            V_ERRO := 'S';
         END IF;
         
         IF V_ERRO IS NULL THEN
            NOVO_CODIGO_SC('PEDIDOEXOL' || V_CDFILIAL || V_CDFILIAL, V_NRPEDEXOL);

            INSERT INTO PEDIDOEXOL
               (CDFILDEST,  CDFILLANC,    NRPEDEXOL,  DTPEDEXOL, IDEMITEXOL,
                CDEMPRESA,  CDFILIOPELOG, IDTIPOEXOL, IDPEDEXOLEXTR, DSDOCDEVOOL)
            VALUES
               (V_CDFILIAL, V_CDFILIAL,   SUBSTR(V_NRPEDEXOL,11,10),  V_DATAEFETIVACAO, '1',
                V_CDEMPRESA, V_CDFILIAL, 'A', 'N', 'Interface WMS ArMHAzena');
         END IF;
      END IF;

      IF V_ERRO IS NULL THEN

         BEGIN
            SELECT CDPRODUTO
              INTO V_CDPRODUTO
              FROM PRODUTO
             WHERE CDARVPROD = V_CODPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODUTO := NULL;
         END;
         
         BEGIN
            SELECT CDLOTENVITOL
              INTO V_CDLOTENVITOL
              FROM LOTENVITMEXOL
             WHERE CDLOTENVITOL = SUBSTR(V_CDLOTE, 1, 10);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDLOTENVITOL := NULL;
         END;
         
         IF NOT V_CDPRODUTO IS NULL THEN
            IF NOT V_CDLOTENVITOL IS NULL THEN
               INSERT INTO ITEMPEDEXOL
                 (CDFILDEST,    CDFILLANC,    NRPEDEXOL, CDPRODUTO,
                  QTPROGENPEOL, DTPROGENPEOL, CDMARCA,   CDLOTENVITOL, DTPROGEMBARQ)
               VALUES
                 (V_CDFILIAL,    V_CDFILIAL,    SUBSTR(V_NRPEDEXOL,11,10), V_CDPRODUTO,
                  V_QUANTIDADE, V_DATAEFETIVACAO, V_CDMARCA, SUBSTR(V_CDLOTE, 1, 10), V_DATAEFETIVACAO);

               -- Inclui reserva
               BEGIN
                  SELECT CALC_ESTOQ_CONS(V_CDFILIAL, Q.CDPRODUTO, Q.DTPOSESTCON) QUANT_ESTOQUE
                    INTO V_QUANT_ESTOQUE
                    FROM (SELECT P.CDPRODUTO, NVL(MAX(DTPOSESTCON), SYSDATE) AS DTPOSESTCON
                            FROM (SELECT DECODE (R.CDPRODARVOL, P.CDPRODESTO, R.CDPRODARVOL, PR.CDPRODUTO) AS CDPRODUTO
                                    FROM RELACPRODOL R, PRODUTO P, PRODUTO PR
                                   WHERE P.CDPRODUTO   = R.CDPRODARVOL
                                     AND P.CDPRODESTO  = PR.CDPRODUTO
                                     AND R.CDPRODARVOL = V_CODPRODUTO
                                     AND R.CDMARCA     = V_CDMARCA) P, POSESTCONS E
                           WHERE E.CDFILIAL  = V_CDFILIAL
                             AND E.CDPRODUTO = P.CDPRODUTO
                           GROUP BY P.CDPRODUTO) Q;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_QUANT_ESTOQUE := 0;
               END;

               V_QTDE_DISP := V_QUANT_ESTOQUE - V_QUANTIDADE;

               IF V_QTDE_DISP >= 0 THEN
                  INSERT INTO RESERVAPEDEXOL
                     (CDFILDEST, CDFILLANC, NRPEDEXOL, CDPRODUTO, CDMARCA,
                      DTPROGENPEOL, QTRESERVESTOL, CDFILRESOL, DTRESEMBARQ)
                  SELECT V_CDFILIAL, V_CDFILIAL, SUBSTR(V_NRPEDEXOL,11,10), V_CDPRODUTO, V_CDMARCA,
                         V_DATAEFETIVACAO, V_QUANTIDADE, V_CDFILIAL, CALCULA_DATAEMBARQUE_OL(V_CDFILIAL, V_CDFILIAL, V_CDPRODUTO, V_DATAEFETIVACAO)
                    FROM DUAL
                   WHERE NOT EXISTS (SELECT 1
                                       FROM RESERVAPEDEXOL R
                                      WHERE R.CDFILDEST    = V_CDFILIAL
                                        AND R.CDFILLANC    = V_CDFILIAL
                                        AND R.NRPEDEXOL    = SUBSTR(V_NRPEDEXOL,11,10)
                                        AND R.CDPRODUTO    = V_CDPRODUTO
                                        AND R.CDMARCA      = V_CDMARCA
                                        AND R.DTPROGENPEOL = V_DATAEFETIVACAO);
               ELSE
                  INSERE_LOGITEM(V_SEQLOGITEM);
                  V_DESCERRO := 'No foi possvel efetuar a reserva do produto '||V_CODPRODUTO||'.';
                  
                  INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
                  VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);
                  
                  V_ERRO := 'S';
               END IF;
            ELSE
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Lote '|| SUBSTR(V_CDLOTE, 1, 10) || ' no cadastrado.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         ELSE
            INSERE_LOGITEM(V_SEQLOGITEM);
            V_DESCERRO := 'Produto '|| V_CODPRODUTO || ' no cadastrado.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);
            
            V_ERRO := 'S';
         END IF;
      END IF;
      
      IF V_ERRO IS NULL THEN
         INSERE_LOGITEM(V_SEQLOGITEM);
         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_ERRO, '4', V_SEQLOGITEM);
      END IF;
   END LOOP;
   
   P_ERRO := V_DESCERRO;
   COMMIT;
   CLOSE C_MOV_ESTOQUE;
EXCEPTION
   WHEN OTHERS THEN
      IF C_MOV_ESTOQUE%ISOPEN THEN
         CLOSE C_MOV_ESTOQUE;
      END IF;
      V_DESCERRO := SQLERRM(SQLCODE);
      P_ERRO     := V_DESCERRO;
     
      INSERE_LOGITEM(V_SEQLOGITEM);
      INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
      VALUES('Movimentao de Estoque', V_NRDOCUMENTO, V_DESCERRO, '4', V_SEQLOGITEM);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MHA_IMPORTA_MOV_ESTOQUE','5.87.XXX'); END;
/